<template>
  <v-list>
      <v-list-item>
        <v-switch label="ファイルサーバへ保存" v-model="fsvr"/>
      </v-list-item>
    <div v-for="(item, i) in items" :key="i">
      <v-list-item>
        <v-icon>mdi-download</v-icon>
        <v-btn @click="download(item.key)">{{ item.disp }}</v-btn>
      </v-list-item>
      <v-list-item>
        <v-list-item-action>
          <v-icon>mdi-upload</v-icon>
        </v-list-item-action>
        <v-list-item-content>
          <v-list-item-title>
            <label>
              {{ item.disp }}復元
              <input
                class="file-button"
                type="file"
                @change="loadFile($event, item.key)"
              />
            </label>
          </v-list-item-title>
        </v-list-item-content>
      </v-list-item>
    </div>
    <a ref="flink" href="" download="data.json"/>
  </v-list>
</template>

<script>
export default {
  data: () => ({
    items: [
      { disp: "給油データ", key: "gasData" },
      { disp: "整備データ", key: "mainteData" },
      { disp: "ベストラップ", key: "lapData" },
      { disp: "アライメント", key: "alignData" },
    ],
    fsvr: true,
  }),
  methods: {
    download(key) {
      const data = localStorage.getItem(key);
      const blob = new Blob([data], {
        type: "application/json",
      });
      const today = new Date();
      const sdate = `${today.getFullYear()}${('0' + (today.getMonth()+1)).slice(-2)}${('0' + today.getDate()).slice(-2)}`;
      if(this.fsvr){
        let params = new FormData();
        params.append('file', blob, `${key}_${sdate}.json`);
        this.$axios.$post(`/fsvr/`, params)
      }
      else {
        let link = this.$refs.flink;
        link.href = window.URL.createObjectURL(blob);
        link.download = `${key}_${sdate}.json`;
        link.click();
      }
    },

    saveAs(data, name) {
      var link = document.createElement("a");
      document.body.appendChild(link);
      link.href = window.URL.createObjectURL(data);
      link.download = name;
      link.click();
      document.body.removeChild(link);
    },

    async loadFile(event, key) {
      console.log(`key:${key}`);
      const files = event.target.files || event.dataTransfer.files;
      const file = files[0];
      const data = await this.getFileData(file);
      localStorage.setItem(key, data);
    },

    getFileData(file) {
      return new Promise((resolve, reject) => {
        const reader = new FileReader();
        reader.readAsText(file);
        reader.onload = () => resolve(reader.result);
        reader.onerror = (error) => reject(error);
      });
    },
  },
};
</script>
